<template>
    <h1>Project Detail View</h1>
    <button type="button" @click="loadAllUsers">User laden</button>
    <button type="button" @click="loadCurrentUser">Aktuellen User laden</button>
    <p>{{ project }}</p>

    <div v-if="isUserLoading" class="lds-circle"><div></div></div>

    <RouterLink :to="'/projects/' + (project?.projectId - 1)">Vorheriges Projekt</RouterLink>
    <RouterLink :to="'/projects/' + (project?.projectId + 1)">Nächstes Projekt</RouterLink>
</template>

<script setup>
    import {useRoute} from "vue-router";
    import {useProjectStore} from "@/store/ProjectStore";
    import {computed, onBeforeUnmount, onMounted, ref} from "vue";
    import axios from "axios";
    import {useUserStore} from "@/store/UserStore";

    const route = useRoute()
    const projectStore = useProjectStore()
    const userStore = useUserStore()
    const isUserLoading = ref(false)

    const project = computed(() => {
        console.log("Recalculating computed property")
        return projectStore.projects.find(potentiallyCorrectProject => potentiallyCorrectProject.projectId === parseInt(route.params.projectId))
    })

    console.log(parseInt(route.params.projectId))

    function loadAllUsers() {
        userStore.loadAllUsers()
    }

    async function loadCurrentUser() {
        isUserLoading.value = true
        try {
            await userStore.ensureUser(route.params.projectId)
            console.log("Success")
        } catch (err) {
            console.log(err)
            if(err.response.status === 404) {
                alert("Den User gibts nicht")
            }
        }
        isUserLoading.value = false
    }

    function onWindowResize(event) {
        console.log(event.currentTarget)
    }
    let intervalId;

    onMounted(function () {
        loadCurrentUser()
        intervalId = setInterval(() => console.log('Interval'))
        window.addEventListener('resize', onWindowResize)
    })

    onBeforeUnmount(() => {
        window.removeEventListener('resize', onWindowResize)
        clearInterval(intervalId)
    })
</script>

<style scoped>
.lds-circle {
    display: inline-block;
    transform: translateZ(1px);
}
.lds-circle > div {
    display: inline-block;
    width: 64px;
    height: 64px;
    margin: 8px;
    border-radius: 50%;
    background: #27ff1c;
    animation: lds-circle 2.4s cubic-bezier(0, 0.2, 0.8, 1) infinite;
}
@keyframes lds-circle {
    0%, 100% {
        animation-timing-function: cubic-bezier(0.5, 0, 1, 0.5);
    }
    0% {
        transform: rotateY(0deg);
    }
    50% {
        transform: rotateY(1800deg);
        animation-timing-function: cubic-bezier(0, 0.5, 0.5, 1);
    }
    100% {
        transform: rotateY(3600deg);
    }
}

</style>